Option Strict On
Option Explicit On

#Region " Imports "
Imports System.Windows.Forms
Imports Mono.Cecil.Cil
#End Region

Namespace Reflexil.Editors

    Public Class NotSupportedOperandEditor
        Inherits TextBox
        Implements IOperandEditor

#Region " Properties "
        Public ReadOnly Property IsOperandHandled(ByVal operand As Object) As Boolean Implements IOperandEditor.IsOperandHandled
            Get
                Return True
            End Get
        End Property

        Public ReadOnly Property Label() As String Implements IOperandEditor.Label
            Get
                Return "[Not supported]"
            End Get
        End Property
#End Region

#Region " Methods "
        Public Sub New()
            Me.Dock = DockStyle.Fill
            Me.ReadOnly = True
        End Sub

        Public Function CreateInstruction(ByVal worker As Mono.Cecil.Cil.CilWorker, ByVal opcode As Mono.Cecil.Cil.OpCode) As Mono.Cecil.Cil.Instruction Implements IOperandEditor.CreateInstruction
            Throw New NotImplementedException
        End Function

        Public Sub Initialize(ByVal mdef As Mono.Cecil.MethodDefinition) Implements IOperandEditor.Initialize
        End Sub

        Public Sub SelectOperand(ByVal operand As Object) Implements IOperandEditor.SelectOperand
            Text = operand.ToString
        End Sub
#End Region

    End Class

End Namespace

