Option Strict On
Option Explicit On

#Region " Imports "
Imports Mono.Cecil.Cil
Imports System.Windows.Forms
#End Region

Namespace Reflexil.Editors

    Public MustInherit Class GenericOperandEditor(Of T)
        Inherits TextBox
        Implements IOperandEditor

#Region " Properties "
        Public ReadOnly Property IsOperandHandled(ByVal operand As Object) As Boolean Implements IOperandEditor.IsOperandHandled
            Get
                Return TypeOf (operand) Is T
            End Get
        End Property

        Public ReadOnly Property Label() As String Implements IOperandEditor.Label
            Get
                Return GetType(T).Name
            End Get
        End Property

        Public ReadOnly Property SelectedOperand() As T
            Get
                Return DirectCast(Convert.ChangeType(Text, GetType(T)), T)
            End Get
        End Property
#End Region

#Region " Methods "
        Public Sub New()
            Me.Dock = DockStyle.Fill
        End Sub

        Public MustOverride Function CreateInstruction(ByVal worker As CilWorker, ByVal opcode As OpCode) As Instruction Implements IOperandEditor.CreateInstruction

        Public Sub Initialize(ByVal mdef As Mono.Cecil.MethodDefinition) Implements IOperandEditor.Initialize
        End Sub

        Public Sub SelectOperand(ByVal operand As Object) Implements IOperandEditor.SelectOperand
            Text = operand.ToString
        End Sub
#End Region

    End Class

End Namespace
