Option Explicit On
Option Strict On

#Region " Imports "
Imports System.Windows.Forms
Imports Reflexil.Editors
Imports Reflexil.Handlers
Imports Mono.Cecil.Cil
#End Region

Namespace Reflexil.Forms

    Public Class CreateInstructionForm

#Region " Events "
        Private Sub ButInsertBefore_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButInsertBefore.Click
            Dim newins As Instruction = CreateInstruction()
            If Not IsNothing(newins) Then
                Handler.MethodDefinition.Body.CilWorker.InsertBefore(Handler.SelectedInstruction, newins)
            End If
        End Sub

        Private Sub ButInsertAfter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButInsertAfter.Click
            Dim newins As Instruction = CreateInstruction()
            If Not IsNothing(newins) Then
                Handler.MethodDefinition.Body.CilWorker.InsertAfter(Handler.SelectedInstruction, newins)
            End If
        End Sub

        Private Sub ButAppend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButAppend.Click
            Dim newins As Instruction = CreateInstruction()
            If Not IsNothing(newins) Then
                Handler.MethodDefinition.Body.CilWorker.Append(newins)
            End If
        End Sub

        Protected Overrides Sub Operands_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs)
            MyBase.Operands_SelectedIndexChanged(sender, e)
            If Not IsNothing(Handler) Then
                ButInsertBefore.Enabled = Not IsNothing(Handler.SelectedInstruction) AndAlso Not TypeOf (Operands.SelectedItem) Is NotSupportedOperandEditor
                ButInsertAfter.Enabled = Not IsNothing(Handler.SelectedInstruction) AndAlso Not TypeOf (Operands.SelectedItem) Is NotSupportedOperandEditor
                ButAppend.Enabled = Not TypeOf (Operands.SelectedItem) Is NotSupportedOperandEditor
            End If
        End Sub

        Private Sub CreateForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Operands_SelectedIndexChanged(Me, EventArgs.Empty)
            OpCodes_SelectedIndexChanged(Me, EventArgs.Empty)
        End Sub
#End Region

#Region " Methods "
        Public Overloads Function ShowDialog(ByVal handler As MethodDefinitionHandler) As DialogResult
            FillControls(Handler)
            Return MyBase.ShowDialog(handler)
        End Function
#End Region

    End Class

End Namespace
