Option Strict On
Option Explicit On

#Region " Imports "
Imports System.Windows.Forms
Imports Reflexil.Editors
Imports Reflexil.Handlers
Imports Mono.Cecil.Cil
#End Region

Namespace Reflexil.Forms

    Public Class EditInstructionForm

#Region " Events "
        Private Sub ButUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButUpdate.Click
            Dim newins As Instruction = CreateInstruction()
            If Not IsNothing(newins) Then
                Handler.MethodDefinition.Body.CilWorker.Replace(Handler.SelectedInstruction, newins)
            End If
        End Sub

        Protected Overrides Sub Operands_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs)
            MyBase.Operands_SelectedIndexChanged(sender, e)
            If Not IsNothing(Handler) Then
                ButUpdate.Enabled = Not IsNothing(Handler.SelectedInstruction) AndAlso Not TypeOf (Operands.SelectedItem) Is NotSupportedOperandEditor
            End If
        End Sub

        Private Sub EditForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Operands_SelectedIndexChanged(Me, EventArgs.Empty)
            OpCodes_SelectedIndexChanged(Me, EventArgs.Empty)
            If Not IsNothing(Handler.SelectedInstruction) AndAlso Not IsNothing(Handler.SelectedInstruction.Operand) Then
                DirectCast(Operands.SelectedItem, IOperandEditor).SelectOperand(Handler.SelectedInstruction.Operand)
            End If
        End Sub
#End Region

#Region " Methods "
        Public Overloads Function ShowDialog(ByVal handler As MethodDefinitionHandler) As DialogResult
            FillControls(handler)
            If Not IsNothing(handler.SelectedInstruction) Then
                For Each editor As IOperandEditor In Operands.Items
                    If Not IsNothing(handler.SelectedInstruction.Operand) Then
                        If editor.IsOperandHandled(handler.SelectedInstruction.Operand) Then
                            Operands.SelectedItem = editor
                            Operands_SelectedIndexChanged(Me, EventArgs.Empty)
                            Exit For
                        End If
                    End If
                Next
                OpCodes.SelectedItem = handler.SelectedInstruction.OpCode
            End If

            Return MyBase.ShowDialog(handler)
        End Function
#End Region

    End Class

End Namespace

