Option Explicit On
Option Strict On

#Region " Imports "
Imports Mono.Cecil
Imports Mono.Cecil.Cil
Imports Reflexil.Wrappers
#End Region

Namespace Reflexil.Forms

    Public Class InstructionSelectForm

#Region " Properties "
        Public ReadOnly Property SelectedInstructions() As List(Of Instruction)
            Get
                Dim result As New List(Of Instruction)
                For Each wrapper As InstructionWrapper In LbxSelection.Items
                    result.Add(wrapper.Item)
                Next
                Return result
            End Get
        End Property
#End Region

#Region " Events "
        Private Sub LbxInstructions_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles LbxInstructions.DoubleClick
            If Not IsNothing(LbxInstructions.SelectedItem) Then
                LbxSelection.Items.Add(DirectCast(LbxInstructions.SelectedItem, ICloneable).Clone())
            End If
        End Sub

        Private Sub LbxSelection_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles LbxSelection.DoubleClick
            If Not IsNothing(LbxSelection.SelectedItem) Then
                LbxSelection.Items.Remove(LbxSelection.SelectedItem)
            End If
        End Sub

        Private Sub ButTop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButTop.Click
            MoveSelection(0)
        End Sub

        Private Sub ButUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButUp.Click
            MoveSelection(LbxSelection.SelectedIndex - 1)
        End Sub

        Private Sub ButDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButDown.Click
            MoveSelection(LbxSelection.SelectedIndex + 1)
        End Sub

        Private Sub ButBottom_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButBottom.Click
            MoveSelection(LbxSelection.Items.Count - 1)
        End Sub
#End Region

#Region " Methods "
        Public Sub New(ByVal mdef As MethodDefinition, ByVal instructions As List(Of Instruction), ByVal selectedinstructions As List(Of Instruction))
            InitializeComponent()

            For Each ins As Instruction In instructions
                LbxInstructions.Items.Add(New InstructionWrapper(ins, mdef))
            Next

            For Each ins As Instruction In selectedinstructions
                LbxSelection.Items.Add(New InstructionWrapper(ins, mdef))
            Next
        End Sub

        Private Sub MoveSelection(ByVal newindex As Integer)
            Dim selection As Object = LbxSelection.SelectedItem
            If Not IsNothing(selection) AndAlso newindex >= 0 AndAlso newindex < LbxSelection.Items.Count Then
                Dim index As Integer = LbxSelection.SelectedIndex
                LbxSelection.Items.Remove(selection)
                LbxSelection.Items.Insert(newindex, selection)
                LbxSelection.SelectedIndex = newindex
            End If
        End Sub

#End Region

    End Class

End Namespace
