Option Strict On
Option Explicit On

#Region " Imports "
Imports Mono.Cecil
Imports Mono.Cecil.Cil
Imports System.Windows.Forms
Imports Reflexil.Editors
Imports Reflexil.Handlers
#End Region

Namespace Reflexil.Forms

    Public Class ReflexilWindow

#Region " Fields "
        Private m_handlers As New List(Of IHandler)
#End Region

#Region " Methods "
        Public Sub New()
            InitializeComponent()

            m_handlers.Add(New ModuleDefinitionHandler())
            m_handlers.Add(New MethodDefinitionHandler())
            m_handlers.Add(New NotSupportedHandler())
        End Sub

        Public Sub HandleItem(ByVal item As Object)
            TabControl.TabPages.Clear()
            For Each Handler As IHandler In m_handlers
                If Handler.IsItemHandled(item) Then
                    Dim tabpage As New TabPage(Handler.Label)
                    TabControl.TabPages.Add(tabpage)
                    If TypeOf (Handler) Is Control Then
                        Dim ctl As Control = DirectCast(Handler, Control)
                        tabpage.Controls.Add(ctl)
                        ctl.Dock = DockStyle.Fill
                    End If
                    tabpage.Tag = Handler
                    Handler.HandleItem(item)
                    Exit For
                End If
            Next
        End Sub
#End Region

    End Class

End Namespace
