Option Explicit On
Option Strict On

#Region " Imports "
Imports Mono.Cecil.Cil
Imports Mono.Cecil
#End Region

Namespace Reflexil.Wrappers

    Public Class InstructionWrapper
        Implements IWrapper(Of Instruction)
        Implements ICloneable

#Region " Fields "
        Private m_mdef As MethodDefinition
        Private m_instruction As Instruction
#End Region

#Region " Properties "
        Public Property Item() As Instruction Implements IWrapper(Of Instruction).Item
            Get
                Return m_instruction
            End Get
            Set(ByVal value As Instruction)
                m_instruction = value
            End Set
        End Property

        Public Property MethodDefinition() As MethodDefinition Implements IWrapper(Of Instruction).MethodDefinition
            Get
                Return m_mdef
            End Get
            Set(ByVal value As MethodDefinition)
                m_mdef = value
            End Set
        End Property
#End Region

#Region " Methods "
        Public Sub New()
        End Sub

        Public Sub New(ByVal instruction As Instruction, ByVal mdef As MethodDefinition)
            m_instruction = instruction
            m_mdef = mdef
        End Sub

        Public Overrides Function ToString() As String
            If Not IsNothing(m_mdef) Then
                Return OperandDisplayHelper.ToString(m_mdef, m_instruction)
            End If
            Return String.Empty
        End Function

        Public Function CreateInstruction(ByVal worker As CilWorker, ByVal opcode As OpCode) As Instruction Implements IWrapper(Of Instruction).CreateInstruction
            Return worker.Create(opcode, Item)
        End Function

        Public Function Clone() As Object Implements System.ICloneable.Clone
            Return New InstructionWrapper(m_instruction, m_mdef)
        End Function
#End Region

    End Class

End Namespace
