Option Explicit On
Option Strict On

#Region " Imports "
Imports Mono.Cecil.Cil
Imports Mono.Cecil
#End Region

Namespace Reflexil.Wrappers

    Public Class ParameterWrapper
        Implements IWrapper(Of ParameterDefinition)

#Region " Fields "
        Private m_mdef As MethodDefinition
        Private m_parameter As ParameterDefinition
#End Region

#Region " Properties "
        Public Property Item() As ParameterDefinition Implements IWrapper(Of ParameterDefinition).Item
            Get
                Return m_parameter
            End Get
            Set(ByVal value As ParameterDefinition)
                m_parameter = value
            End Set
        End Property

        Public Property MethodDefinition() As MethodDefinition Implements IWrapper(Of ParameterDefinition).MethodDefinition
            Get
                Return m_mdef
            End Get
            Set(ByVal value As MethodDefinition)
                m_mdef = value
            End Set
        End Property
#End Region

#Region " Methods "
        Public Sub New()
        End Sub

        Public Sub New(ByVal parameter As ParameterDefinition, ByVal mdef As MethodDefinition)
            m_parameter = parameter
            m_mdef = mdef
        End Sub

        Public Overrides Function ToString() As String
            Return OperandDisplayHelper.ToString(m_parameter)
        End Function

        Public Function CreateInstruction(ByVal worker As CilWorker, ByVal opcode As OpCode) As Instruction Implements IWrapper(Of ParameterDefinition).CreateInstruction
            Return worker.Create(opcode, Item)
        End Function
#End Region

    End Class

End Namespace
