Option Explicit On
Option Strict On

#Region " Imports "
Imports Mono.Cecil.Cil
Imports Mono.Cecil
#End Region

Namespace Reflexil.Wrappers

    Public Class VariableWrapper
        Implements IWrapper(Of VariableDefinition)

#Region " Fields "
        Private m_mdef As MethodDefinition
        Private m_variable As VariableDefinition
#End Region

#Region " Properties "
        Public Property Item() As VariableDefinition Implements IWrapper(Of VariableDefinition).Item
            Get
                Return m_variable
            End Get
            Set(ByVal value As VariableDefinition)
                m_variable = value
            End Set
        End Property

        Public Property MethodDefinition() As MethodDefinition Implements IWrapper(Of VariableDefinition).MethodDefinition
            Get
                Return m_mdef
            End Get
            Set(ByVal value As MethodDefinition)
                m_mdef = value
            End Set
        End Property
#End Region

#Region " Methods "
        Public Sub New()
        End Sub

        Public Sub New(ByVal variable As VariableDefinition, ByVal mdef As MethodDefinition)
            m_variable = variable
            m_mdef = mdef
        End Sub

        Public Overrides Function ToString() As String
            Return OperandDisplayHelper.ToString(m_variable)
        End Function

        Public Function CreateInstruction(ByVal worker As CilWorker, ByVal opcode As OpCode) As Instruction Implements IWrapper(Of VariableDefinition).CreateInstruction
            Return worker.Create(opcode, Item)
        End Function
#End Region

    End Class

End Namespace
